/**
 * Classe mre de tous ouvrages
 * 
 * @author anab
 */
public abstract class Ouvrage {

	int ID;
	String titre;
	String dateDePublication;
	int examplaires;

	int heure_mise_a_jour = -1; // dernier mise-a-jour
	boolean disponible = true;
	int tempsPourDevenirDisponible = 0;

	public Ouvrage(int ID, String titre, String dateDePublication) {
		this.ID = ID;
		this.titre = titre;
		this.dateDePublication = dateDePublication;
	}

	// accesseurs

	/**
	 * @return ID
	 */
	public int getID() {
		return ID;
	}

	/**
	 * mettre  jour son tat
	 */
	public void update(int time) {
		if (time == heure_mise_a_jour)
			return; // dj  jour

		heure_mise_a_jour = time;

		if (tempsPourDevenirDisponible <= 0) {
			// ouvrage disponible
			tempsPourDevenirDisponible = 0;
			disponible = true;
		} else {
			// ouvrage impret, mais le temps passe
			--tempsPourDevenirDisponible;
			disponible = false;
		}
	}

	/**
	 * decrir son tat
	 */
	public void print_state() {
		System.out.println(ID + ": disponible:" + disponible + " dans "
				+ tempsPourDevenirDisponible + "h");
	}

	/**
	 * acceder l'ouvrage
	 */
	public abstract boolean acces(int t);
}
